@Echo off
SET LogPath=C:\OEM\AcerLogs\UserAlaunch.log
echo. >> %LogPath%
echo ------ Enter %~dpnx0 on %DATE% %TIME% ------ >> %LogPath%
for /f "skip=2 tokens=3" %%A in ('reg query HKLM\Software\OEM\Metadata /v Brand') do set Brand=%%A
Echo [Brand] is %Brand% >>%LogPath%
set BrandCheck=%Brand%
If /i "%Brand%" equ "Packard" (
	set BrandCheck=Packard Bell
)
Echo [BrandCheck] = %BrandCheck% >>%LogPath%
SET @Flag=CHECK
SET Count=0
SET APName=Power Management

call :Re-Install

find /i "FLOW=CD2D_REHDD" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is CD2D_REHDD Flow, No Need Installation Detect >> %LogPath%
	SET @Flag=NoCHECK
)

find /i "FLOW=CD2D" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is CD2D Flow, No Need Installation Detect >> %LogPath%
	SET @Flag=NoCHECK
)
find /i "FLOW=D2D" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is D2D Flow, No Need Installation Detect >> %LogPath%
	SET @Flag=NoCHECK
)
if %@Flag% EQU CHECK (
	echo Flag = %@Flag%, Not D2D or CD2D Flow, Do Installation Detect >> %LogPath%
	call :Check
)


echo ------ Leave %~dpnx0 on %DATE% %TIME% ------ >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
exit /b 0








:Re-Install
start /w setup.exe -s -log "c:\oem\powerlog.txt"
cscript.exe _Timeout.vbs 15
exit /b 0


:Check
IF %Count% GEQ 3 call :ERROR && exit /b 0
Set /A Count+=1
Echo Install at %Count%th times >> %LogPath%

IF NOT EXIST "C:\Program Files\%BrandCheck%\%BrandCheck% Power Management\ePowerTray.exe" (
	echo No Found ePowerTray.exe  >> %LogPath%
	call :Re-Install
	call :Check
) ELSE (
	echo Install Power Management PASS >> %LogPath%
)
exit /b 0


:ERROR
echo. >> %LogPath%
echo. >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
shutdown /r /t 5
pause
exit /b 0